/*
	$Id: AnnotatedData.java 7150 2016-04-27 06:38:21Z nicklas $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

import java.util.Set;

import net.sf.basedb.core.data.annotations.AnnotationLink;

/**
	This class extends the {@link CommonData} class and implements the
	{@link AnnotatableData} interface. Ie. by extending this class a data item 
	becomes annotatable.

	@author Nicklas
	@version 2.0
	@see AnnotatableData
	@see net.sf.basedb.core.AnnotatedItem
	@see <a href="../../../../../../html/developer/api/data_api.annotations.html">Developer documentation: Annotations</a>
*/
public abstract class AnnotatedData
	extends CommonData
	implements AnnotatableData, LoggableData
{

	public AnnotatedData()
	{}
	
	/*
		From the AnnotatableData interface
		-------------------------------------------
	*/
	private AnnotationSetData annotationSet;
	@Override
	public AnnotationSetData getAnnotationSet()
	{
		return annotationSet;
	}
	@Override
	public void setAnnotationSet(AnnotationSetData annotationSet)
	{
		this.annotationSet = annotationSet;
	}
	private Set<AnnotationLink> links;
	@Override
	public Set<AnnotationLink> getAnnotations()
	{
		return links;
	}
	void setAnnotations(Set<AnnotationLink> links)
	{
		this.links = links;
	}
	// -------------------------------------------
	
}
