/*
	$Id: Order.java 4889 2009-04-06 12:52:39Z nicklas $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.query;

/**
	An ordering query element. This query element appears in the <code>ORDER BY</code>
	part of a {@link Query} and is used to sort the result. Typically an
	order by clause consists of an expression and a keyword telling if the
	results should be sorted in ascending or descending order.
	<pre class="code">
SELECT usr
FROM UserData usr
ORDER BY usr.name ASC
</pre>

	<p>
	Order elements can be created by the {@link Orders} factory class.

	@author Nicklas
	@version 2.0
	@base.modified $Date: 2009-04-06 14:52:39 +0200 (må, 06 apr 2009) $
*/
public interface Order
	extends QueryElement
{}
