/*
	$Id $

	Copyright (C) 2016 Nicklas Nordborg
	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.test.extension.jar1;

import net.sf.basedb.test.extension.IActionButton;
import net.sf.basedb.util.extensions.ActionFactory;
import net.sf.basedb.util.extensions.InvokationContext;

/**
	Used for testing the extension class loading system.
	@see TestExtensions
*/
public class One 
	implements IActionButton, ActionFactory<IActionButton>
{
	
	public One()
	{}

	@Override
	public String getTitle() 
	{
		return "One";
	}

	@Override
	public String getIcon() 
	{
		return "one.png";
	}

	@Override
	public int getType()
	{
		return 1;
	}

	@Override
	public boolean isDisabled() 
	{
		return false;
	}

	@Override
	public boolean prepareContext(InvokationContext<? super IActionButton> context) 
	{
		return true;
	}

	@Override
	public IActionButton[] getActions(InvokationContext<? super IActionButton> context) 
	{
		return new IActionButton[] { this };
	}

}
