/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var DiskUsage = function()
{
	var diskUsage = {};
	
	/**
	 	Initialize auto-elements
	 */
	diskUsage.initElements = function(element, autoInit)
	{
		if (autoInit == 'impersonate-user')
		{
			Buttons.addClickHandler(element, diskUsage.impersonateUser);
		}
		else if (autoInit == 'view-details')
		{
			Buttons.addClickHandler(element, diskUsage.viewDetails);
		}
	}
	
	/**
		Initialize the page.
	*/
	diskUsage.initPage = function()
	{
		var pageId = Doc.getPageId();		
		TabControl.setSwitchFunction('main', diskUsage.switchTab);
		
		var tableAttributes = {};
		
		if (pageId == 'list-users')
		{
			tableAttributes['table-id'] = 'users';
		}
		else if (pageId == 'list-groups')
		{
			tableAttributes['table-id'] = 'groups';
		}
		Events.addEventHandler('changeSummary', 'click', diskUsage.changeSummary);
		Buttons.addClickHandler('btnColumns', Buttons.configureColumns, tableAttributes);
	}
	
	
	diskUsage.switchTab = function(event)
	{
		var target = event.target;
		var cmd = Data.get(target, 'cmd');
		var url = 'index.jsp?ID='+App.getSessionId();
		url += '&cmd='+cmd;
		location.replace(url);
	}

	diskUsage.changeSummary = function(event)
	{
		if (event.target.type == 'radio') event.target.form.submit();
	}
	
	diskUsage.impersonateUser = function(event)
	{
		var userId = Data.get(event.currentTarget, 'user-id');
		var url = '../../impersonate.jsp?ID='+App.getSessionId();
		url += '&user_id='+userId;
		Dialogs.openPopup(url, 'Impersonate', 450, 300);
	}
	
	diskUsage.viewDetails = function(event)
	{
		var url = 'details/index.jsp?ID='+App.getSessionId();
		url += '&cmd=ViewItem';
		url += '&item_id='+Data.get(event.currentTarget, 'item-id');
		url += '&item_type='+Data.get(event.currentTarget, 'item-type');
		location.href = url;
	}

	return diskUsage;
}();

Doc.addElementInitializer(DiskUsage.initElements);
Doc.onLoad(DiskUsage.initPage);