<%-- $Id: edit_reporterlist.jsp 6314 2013-09-02 12:47:53Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ReporterList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.REPORTERLIST;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	String name = null;
	ReporterList reporterList = null;
	boolean addReporters = false;
	boolean mergeReporterLists = false;
	int numSelectedLists = cc.getSelected().size();
	String formId = request.getParameter("formId");
	String fromContext = Values.getString(request.getParameter("fromContext"), "REPORTER");
	String subContext = request.getParameter("subContext");

	if (itemId == 0)
	{
		title = "Create reporter list";
		cc.removeObject("item");
		addReporters = Values.getBoolean(request.getParameter("addReporters"));
		mergeReporterLists = !addReporters && numSelectedLists > 0;
		name = request.getParameter("name");
		if (name == null) name = Values.getString(cc.getPropertyValue("name"), "New reporter list");
	}
	else
	{
		reporterList = ReporterList.getById(dc, itemId);
		reporterList.checkPermission(Permission.WRITE);
		name = reporterList.getName();
		cc.setObject("item", reporterList);
		title = "Edit reporter list -- " + HTML.encodeTags(reporterList.getName());
	}
	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), reporterList);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,~reporterlists.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<div id="page-data" class="datacontainer"
			data-num-selected-lists="<%=numSelectedLists %>"
			data-add-reporters="<%=addReporters ? formId : "" %>"
		></div>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="reporterList">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="fromContext" value="<%=fromContext%>">
		<%
		if (subContext != null)
		{
			%>
			<input type="hidden" name="subContext" value="<%=subContext%>">
			<%
		}
		%>
		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=reporterList != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Reporter list" helpid="reporterlist.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=reporterList == null ? "focus-select" : "focus" %>" 
					type="text" name="name" 
					value="<%=HTML.encodeTags(name)%>" 
					maxlength="<%=ReporterList.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>External ID</th>
				<td><input class="text" type="text" name="external_id" 
					value="<%=HTML.encodeTags(reporterList == null ? Values.getString(cc.getPropertyValue("externalId")) : reporterList.getExternalId())%>" 
					maxlength="<%=ReporterList.MAX_EXTERNAL_ID_LENGTH%>"></td>
				<td></td>
			</tr>
			<%
			if (addReporters)
			{
				%>
				<tr>
					<th>Which reporters?</th>
					<td>
						<input type="radio" name="which" id="whichSelected" value="selected"
							><label for="whichSelected" id="lblSelected">Selected items</label><br>
						<input type="radio" name="which" id="whichPage" value="page"
							><label for="whichPage">Current page</label><br>
						<input type="radio" name="which" id="whichAll" value="all" checked
							><label for="whichAll">All pages</label><br>
					</td>
					<td></td>
				</tr>
				<%
			}
			else if (mergeReporterLists)
			{
				%>
				<tr>
					<th>Add reporters?</th>
					<td>
						<input type="radio" name="create" id="createEmpty" value=""
							><label for="createEmpty"
							title="The new reporter list will be empty">No</label><br>
						<input type="radio" name="create" id="createUnion" value="union" checked
							><label for="createUnion" 
								title="The new reporter list contains all reporters from the selected lists"
								>Union of selected lists</label> 
								<base:icon image="set_operations/union_small.png" /><br>
						<input type="radio" name="create" id="createIntersection" value="intersection"
							><label for="createIntersection" 
								title="The new reporter lists contains only reporters that are present in ALL selected lists"
								>Intersection of selected lists</label> 
								<base:icon image="set_operations/intersection_small.png" /><br>
						<input type="radio" name="create" id="createCount" value="count"
							><label for="createCount"
								title="The new reporter lists contains only reporters that are present in some of selected lists"
								>Present in at least</label>
							<input type="text" class="text" name="minCount" id="minCount" 
								style="width: 3em;" maxlength="2" value="1">
								of the selected lists (1-<%=numSelectedLists%>).
							<br>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(reporterList == null ? cc.getPropertyValue("description") : reporterList.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
